//
//  MADSingleClass.h
//  MADCore
//
//  Created by 魏修全 on 2018/2/24.
//  Copyright © 2018年 Chengming Lu. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import <WebKit/WebKit.h>
@class MADEventModel;
@class WKWebView;
@class MADContext;



typedef id(^CustomerSplashView)(MADContext *context, NSInteger seconds,NSString *imageUrl,NSString *stageUrl);
typedef id(^CustomerLoadingView)(MADContext *context);
typedef id(^CustomerView)(id);
typedef void(^CustomerScreenshots)(NSString *msgStrm, BOOL tag);
typedef void(^WorkerUpdate)(void);
typedef void(^CrashReporterFinish)(void);
//typedef void(^WorkerEventStartUp)(void);
typedef void(^CustomerLoadingStart)(MADContext *context, NSString *module);
typedef void(^CustomerLoadingEnd)(MADContext *context, NSString *module, BOOL status, id error);
typedef void(^MADP_STATUE)(id);

/**
 *WebView白屏检查枚举值
 */
typedef NS_ENUM(NSUInteger,WebViewShowStatus) {
    WebViewNormalStatus = 0, //正常
    WebViewErrorStatus, //白屏
    WebViewPendStatus, //待决
};

@interface MADSingleClass : NSObject

//#ifdef BURIALPOINT
@property (nonatomic,strong) NSString* enterfuncTime;
@property (nonatomic,strong) NSMutableDictionary* seedDic;
//#endif

@property (nonatomic, strong) id worker; //CSII MADP add

@property (nonatomic,strong)  id  event;

@property (nonatomic, strong) MADEventModel *app_info; //add

@property (nonatomic,copy)CustomerSplashView customerSplash;

@property (nonatomic,copy)CustomerLoadingView customerLoadingTop;

//自定义错误页：处理基于weex场景，weex渲染引擎初始化错误。并非资源拉取失败的错误页
// 返回的自定义view需要是MADErrorView的子类 ！！！
@property (nonatomic,copy)CustomerView customerErrorView;

/** 自定义 防止截屏,录屏页面  tag:NO 截屏回调 YES 录屏回调; 默认NO*/
@property (nonatomic, copy) CustomerScreenshots customerScreenshots;
//weex/web 容器页面渲染开始回调
@property (nonatomic, copy) CustomerLoadingStart customerLoadingStart;
//weex/web 容器页面渲染结束回调
@property (nonatomic, copy) CustomerLoadingEnd customerLoadingEnd;
/**
 (这两个属性在worker里是控制是否注入xhook.js  true不注入 false注入)
 */
// 是否使用代理端口  默认NO
@property (nonatomic,assign) BOOL isUsePortService;
// web是否使用代理端口 默认NO
@property (nonatomic,assign) BOOL isUsePortService_web;

// 监听是否是web页面调用sd, 需要处理请求头参数
@property (nonatomic,assign) BOOL isWebPage;

/// Web 容器的 UserAgent
@property (nonatomic,assign) BOOL isUserAgent;

//异步更新列表  default: yes(sync)
@property (nonatomic,assign) BOOL syncUpdateList;

//worker需要更新
//@property (nonatomic,assign) BOOL workerNeedUpdate;
//worker更新完成
//@property (nonatomic,assign) BOOL workerUpdateComplete;
//@property (nonatomic,copy)WorkerUpdate workerUpdateStart;
//@property (nonatomic,copy)WorkerUpdate workerUpdateFinish;


//@property (nonatomic)Class errorView;


//建议使用 madp_statue_finish替代，在后续的版本中会废弃
//@property (nonatomic,copy)WorkerEventStartUp workerEventStartUp;



#pragma mark - MADP STATUE
//提供MADP SDK实例化过程中的状态
//SDK有默认的处理，如果需要自定义处理，可在状态回调中实现。

//开始初始化
@property (nonatomic,copy)MADP_STATUE madp_statue_start;

//完成初始化
@property (nonatomic,copy)MADP_STATUE madp_statue_finish;

//获取register/central/rope失败
@property (nonatomic,copy)MADP_STATUE madp_statue_get_source_error;




#pragma mark - countly

//sdk 内部使用
@property (atomic,assign) BOOL becomeActive;

//countly 单次发送条数
@property (nonatomic) NSUInteger eventSendThreshold;

//countly 报文加密 default：NO
@property (nonatomic) BOOL countlyEncrypt;

@property (nonatomic,copy)CrashReporterFinish crashReporterFinish;

#pragma mark - 自定义加密
/**
 自定义报文加解密
  包含两种类型，A：只操作body；B：需要借助于url/header/body
  如果使用A类型：
  encryptionsCallBack  输入端为需要加密的body，输出端为加密后的body；
  decryptionsCallBack  输入端为待解密的body，输出端为解密后的body；
  如果使用B类型：
  encryptionsCallBack 输入端为body，输出为{Url:"",Header:{需要添加的key-vlue},Body:"加密后的body"}
  decryptionsCallBack  输入端为{Url:"",Header:{},Body:""}，输出端为解密后的body；
 */

//加解密实现
@property (nonatomic, copy) NSData *(^decryptionsCallBack)(NSData *p0);
@property (nonatomic, copy) NSData *(^encryptionsCallBack)(NSData *p0);

/*
 Resource
 + 作用：用于获取资源文件
 + 入参：
     + url：字符串类型，为文件url请求地址
 + 返回参数：
     + NSDictionary， key: StatusCode 状态吗(NSNumber)/ Body 响应体 (NSData) /Msg 错误描述（NSString）

 Send
 + 作用：发送交易请求
 + 入参：
     + 字节组json类型,其格式为`{"Url":"","Header":{},"Body":""}`
 + 返回：
     + 字节组json类型,`{"StatusCode":1,"Header":{},"Body":""}`
 **/
@property (nonatomic, copy) NSDictionary *(^resourceCallBack)(NSString *p0);
@property (nonatomic, copy) NSDictionary *(^sendCallBack)(NSData *p0);
 

/**
 *isResourceCallback
 *yes: 需要更新, no: 不需要更新
 *
 *isRepoCallback
 *yes: 更新完成
 */
@property (nonatomic, copy) void (^isResourceCallback)(BOOL state);
@property (nonatomic, copy) void (^isRepoCallback)(BOOL state);

//是否单色模式
@property (nonatomic,assign) BOOL isMonochromatic;
//单色模式暴露接口
@property (nonatomic,strong) NSString *isCustomGray;

@property (nonatomic,assign) BOOL isStreamLog;
//白屏检测次数统计
@property (nonatomic,assign) NSInteger whiteScreensCount;
///注册自定义报文加解密
// type == 3 会把url/header/body通过block暴漏；其他的都是暴漏body
// 注意：需要madp_statue_finish中调用
- (long)registryCustomEncryption:(NSInteger) type;
/// 取消注册自定义报文加解密
- (long)cancelCustomEncryption;

///注册交易回调
- (void)registryCommunication;
///注册资源回调
- (void)registryResource;

- (id)registryWorkerNewEnviron;
///注册更新回调
- (void)regisetryIsResourceStatus;
///注册更新状态回调
- (void)regisetryIsRepoStatus;

#pragma mark - Point
/** 启动时间 */
@property (nonatomic,strong) NSString* pointStartTime;
/**展示时间 */
@property (nonatomic,strong) NSString* pointShowTime;

/** startupTimePoint */
@property (nonatomic, copy) void (^startupTimePoint)(NSString *duration);

@property (nonatomic, copy) void (^recordEventPoint)(NSString *eventID, NSString *eventData);
/// 注册value回调
- (void)registryPointData;

@property (nonatomic, copy) void (^pointCallback)(NSString *p0,NSString *p1,NSString *value1,NSString *value2,NSString *code,NSString *dur);

/** enterfuncPoint */
@property (nonatomic, copy) void (^enterfuncPoint)(NSString *url, NSString *title, NSString *custom_type);
/** quitfuncPoint */
@property (nonatomic, copy) void (^quitfuncPoint)(NSString *url, NSString *title, NSString *page_dur);
/** loadingPoint */
@property (nonatomic, copy) void (^loadingPoint)(NSString *url, NSString *title, NSString *page_dur);

/**
MADSingleClass实例
 */
+(instancetype) getInstance;

/**
 字典转json字符串
 @param dic 字典
 */
-(NSString*)dictionaryToJson:(NSDictionary *)dic;

/**
 json字符串转字典
 @param JSONString json串
 */
-(NSDictionary *)parseJSONStringToNSDictionary:(NSString *)JSONString;

/**
 对象转字典(key,value)
 @param entity 对象
 */
-(NSDictionary *) entityToDictionary:(id)entity;

/**
 按大小压缩image返回数据流
 @param image  image对象
 @param size   数据大小(byte)
 */
- (NSData *)compressOriginalImage:(UIImage *)image toMaxDataSizeKBytes:(CGFloat)size;

/**
 创建二维码
 @param Content  二维码内容
 */
-(UIImage *)generateQRCode:(NSString *)Content;

/**
 创建二维码
 @param Content  二维码内容
 @param side     二维码边长
 */
-(UIImage *)generateQRCodeWithSide:(NSString *)Content :(int)side;

/**
 创建条形码
 @param str  条形码内容
 */
-(UIImage *)generateBarCodeWithStr:(NSString *)str;

/**
 创建条形码
 @param str  条形码内容
 @param width  条形码宽度
 @param height  条形码高度
 */
-(UIImage *)generateBarCodeWithStr:(NSString *)str :(int)width :(int)height;

/**
 获取设备IP地址
 @param preferIPv4  是否IPv4
 */
-(NSString *)getIPAddress:(BOOL)preferIPv4;

/**
返回image图片路径
 @param imgData  image数据流
 @param dictionaryName  images所在的文件夹名字可以传nil，weex有个缓存的问题，建议每个功能的图片放在不同的文件夹
 */
-(NSString *)getImageFilePathWithData:(NSData *)imgData inDictionary:(NSString *)dictionaryName;


//CSII MADP add
/**
 往请求头里放置AuthToken，供ServiceWorker鉴权
 */
-(void)setAuthTokenForHTTPHeaderField:(NSMutableURLRequest *)request;

/**
 往请求头里放置stage-type，供worker识别请求来自web or weex
 @param type  传web or weex
 */
-(void)setStageTypeForHTTPHeaderField:(NSMutableURLRequest *)request type:(NSString*)type;

/**
 定制WKWebView的User-Agent
 */
-(void)setCustomUserAgentForWKWebViewConfig:(WKWebViewConfiguration*)config;

- (void)setCustomUserAgentForWKWebView:(WKWebView *)webview;
/**
 校验ServiceWorker起的代理服务器ssl证书信息（公钥和常用名称）
 */
-(BOOL)verifyServerCertInfoWithChallenge:(NSURLAuthenticationChallenge *)challenge;

//获取设备型号（系统API返回）
- (NSString*)getDeviceModel;
//获取设备型号名称 （手动翻译名称）
- (NSString *)getDeviceModelName;
//获取设备型号名称、英寸、ppi
- (NSDictionary *)getDeviceModelInfo;
/**
 获取当前时间
 @return 返回当前时间 格式：mm:ss
 */
- (NSString *)getCurrentTime;
/**
 获取开始时间和结束时间之差
 @return 返回时间差结果 单位：秒
 */
- (NSTimeInterval)pleaseInsertStarTime:(NSString *)starTime andInsertEndTime:(NSString *)endTime;

/**
 获取当前时间戳 毫秒
 */
- (NSString *)getCurrentHourAndMinuteTime;
/**
 获取开始时间和结束时间之差
 @return 返回时间差结果 单位：毫秒
 */
- (NSString *)getTimeDifferenceWithStartTime:(NSString * )startTime;

/**
 *webview 截图-白屏检测
 */
- (void)contrastScreenshotOnWebview:(WKWebView *)webview proportion:(float)proportion withBlock:(void (^)(WebViewShowStatus status))completionBlock;
/**
 解压gif的data为图片数组
 */
-(UIImage *)decodeGifImageByData:(NSData *)data;
/**
 通过worker下载图片
*/
- (void)downLoadImg:(NSString *)urlStr type:(NSString *)type callBack:(void(^)(UIImage *img, NSInteger code))callBack;
/**
 通过worker下载资源
*/
- (void)downLoadResource:(NSMutableURLRequest *)request callBack:(void(^)(NSData *resBody,NSString *header,NSString *contentType, NSInteger code))callBack;
/**
 通过worker下载资源 wkwebview
*/
-(void)downLoadResource:(NSMutableURLRequest *)request withblock:(void(^)(id resp))callBack;

/**
 通过worker下载资源  回调在子线程
*/
- (void)asyncDownLoadResource:(NSMutableURLRequest *)request callBack:(void(^)(NSData *resBody,NSString *header,NSString *contentType, NSInteger code))callBack;

/**
  在framework中查找文件
 */
- (NSString *)getBundleInDynamicFrameworkName:(NSString *)frameworkName fileName:(NSString *)name fileType:(NSString *)type;
/**
 原生发交易（send方式）
 / @param request 构建请求
 / @param params  body中包含的键值对
 / @param callBack 上传结果响应
 */
- (void)sendAPI:(NSMutableURLRequest *)request parameters:(NSDictionary *)params callBack:(void(^)(NSData *resBody,NSString *header, NSInteger code))callBack;

/// 上传数据（单文件/多文件）
/// @param request 构建上传请求
/// @param params  包含每个文件的拼装参数 @{@"FormKey":@"表单key",@"FormValue":@"文件名",@"Data":@"文件二进制数据",}
/// @param callBack 上传结果响应
- (void)upLoadResource:(NSMutableURLRequest *)request parameters:(NSArray*)params callBack:(void(^)(NSData *resBody,NSString *header, NSInteger code))callBack;
/**
 传入数组, 将数组中的元素拼接成string
*/
- (NSString *)stringWithArr:(NSArray *)arr;
/// 清除本地化持久化数据
- (void)clearData;
/// 清除所有资源数据缓存
- (BOOL)clearCache;

@end

@interface MADEventModel : NSObject
@property (nonatomic , copy) NSString *client_id;
@property (nonatomic , copy) NSString *app_id;
@property (nonatomic , copy) NSString *app_secretkey;
@property (nonatomic , copy) NSString *behavior_url;
@property (nonatomic , assign) Boolean behavior_encryptmode;

+(instancetype)instanceWithDict:(NSDictionary *)dict;

@end
